> For the complete documentation index, see [llms.txt](https://docs.sov.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.sov.ai/api-reference/utils.md).

# Utilities

Internal utility functions for data loading, caching, and format conversion.

## Modules

* [Client Side](/api-reference/utils/client-side.md) — API reference for sovai.utils.client\_side
* [Client Side S3](/api-reference/utils/client-side-s3.md) — API reference for sovai.utils.client\_side\_s3
* [Client Side S3 Part High](/api-reference/utils/client-side-s3-part-high.md) — Advanced S3 Partitioned Data Loader
* [Converter](/api-reference/utils/converter.md) — API reference for sovai.utils.converter
* [File Management](/api-reference/utils/file-management.md) — API reference for sovai.utils.file\_management
* [Get Tickers](/api-reference/utils/get-tickers.md) — API reference for sovai.utils.get\_tickers
* [Helpers](/api-reference/utils/helpers.md) — API reference for sovai.utils.helpers
* [Plot](/api-reference/utils/plot.md) — API reference for sovai.utils.plot
* [Port Manager](/api-reference/utils/port-manager.md) — API reference for sovai.utils.port\_manager
* [Stream](/api-reference/utils/stream.md) — API reference for sovai.utils.stream
* [Verbose Utils](/api-reference/utils/verbose-utils.md) — API reference for sovai.utils.verbose\_utils


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.sov.ai/api-reference/utils.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
